<?php

namespace Modules\User\Requests\Admin;

use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Request;
use Illuminate\Foundation\Http\FormRequest;
use Illuminate\Validation\Rule;
use Illuminate\Validation\ValidationException;
use Illuminate\Contracts\Validation\Validator;
use Illuminate\Http\Exceptions\HttpResponseException;
use Modules\User\Enums\UserGenderEnum;
use Modules\User\Enums\UserRoleEnum;

class MemberRequest extends FormRequest
{
    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
    public function authorize()
    {
        $role = UserRoleEnum::admins();
        if (! Auth::check()) {
            return false;
        }
        if(!in_array(Auth::user()->role, $role))
        {
            return false;
        }
        if(Auth::user()->hasModule('members'))
        {
            return true;
        }
        return Auth::check();
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array
     */
    public function rules()
    {
        $roles = UserRoleEnum::users();
        $genders = UserGenderEnum::values();
        $rules =
            [
                'name'=>
                    [
                        'required',
                        'string'
                    ],
                'last_name'=>
                    [
                        'required',
                        'string'
                    ],
                'email'=>
                    [
                        'required',
                        'email',
                        Rule::unique('users','email')->ignore($this->member ?? null)
                    ],
                'phone'=>
                    [
                        'required',
                        'numeric',
                        Rule::unique('users','email')->ignore($this->member ?? null)
                    ],
                'photo'=>
                    [
                        'nullable'
                    ],
                'role'=>
                    [
                        'required',
                        'in:'.implode(',',$roles)
                    ],
                'gender'=>
                    [
                        'required',
                        'in:'.implode(',',$genders)
                    ],
                'birth_date'=>
                    [
                        'required',
                        'date'
                    ],
                'password'=>
                    [
                        $this->member ? 'sometimes' : 'required',
                        'confirmed'
                    ]
            ];


        return $rules;
    }

    /**
     * Get custom attributes for validator errors.
     *
     * @return array
     */
    public function attributes()
    {

        $attributes= [
            'name'=>__('users.name'),
            'last_name'=>__('users.last_name'),
            'email'=>__('users.email'),
            'birth_date'=>__('users.birth_date'),
            'gender'=>__('users.gender'),
            'phone'=>__('users.phone'),
            'photo'=>__('users.photo'),
            'role'=>__('users.role'),
            'password'=>__('users.password'),
            'password_confirmation'=>__('users.password_confirmation'),

        ];

        return $attributes;
    }

    /**
     * Handle a failed validation attempt.
     *
     * Override the parent method action if the request is for AJAX
     *
     * @param Validator $validator
     * @return void
     *
     * @throws ValidationException
     */
    protected function failedValidation(Validator $validator)
    {
        // Change response attitude if the request done via Ajax requests like API requests
        if(Request::wantsJson()){
            $errors = (new ValidationException($validator))->errors();
            throw new HttpResponseException(response()->json(['errors' => $errors], 422));
        } else {
            // Do the original action of the Form request class
            parent::failedValidation($validator);
        }
    }
}
